# HG changeset patch
# User steeven
# Date 1225022758 -28800
# Node ID f36ea3ff247ebb04583f467b793952d382e35a27
# Parent  3fcd0e8969795fd0ca7251a8c209727edf11b798
export patch feature, to be refined

diff -r 3fcd0e896979 -r f36ea3ff247e plugin.xml
--- a/plugin.xml	Sat Oct 18 17:09:47 2008 +0200
+++ b/plugin.xml	Sun Oct 26 20:05:58 2008 +0800
@@ -712,6 +712,13 @@
                id="com.vectrace.MercurialEclipse.team.ActionRevert">
            </action>
            <action
+               label="E&amp;xport patch..."
+               class="com.vectrace.MercurialEclipse.team.ActionExport"
+               tooltip="Export patch to file (hg diff)"
+               menubarPath="team.main/group2"
+               id="com.vectrace.MercurialEclipse.team.ActionExport">
+           </action>           
+           <action
                label="&amp;Import patch..."
                class="com.vectrace.MercurialEclipse.team.ActionImport"
                tooltip="Import patch from file (hg import)"
@@ -791,6 +798,7 @@
       </wizard>
    </extension>
    
+
    <extension point="org.eclipse.ui.newWizards">
       <category
             id="com.vectrace.MercurialEclipse"
diff -r 3fcd0e896979 -r f36ea3ff247e src/com/vectrace/MercurialEclipse/commands/HgImportExportClient.java
--- a/src/com/vectrace/MercurialEclipse/commands/HgImportExportClient.java	Sat Oct 18 17:09:47 2008 +0200
+++ b/src/com/vectrace/MercurialEclipse/commands/HgImportExportClient.java	Sun Oct 26 20:05:58 2008 +0800
@@ -10,7 +10,12 @@
  *******************************************************************************/
 package com.vectrace.MercurialEclipse.commands;
 
+import java.io.FileOutputStream;
+import java.io.IOException;
+import java.util.List;
+
 import org.eclipse.core.resources.IProject;
+import org.eclipse.core.resources.IResource;
 
 import com.vectrace.MercurialEclipse.exception.HgException;
 
@@ -23,4 +28,29 @@
         return command.executeToString();
     }
 
+    public static String exportPatch(IProject project,
+            List<IResource> resources, String patchLocation) throws HgException {
+        HgCommand command = new HgCommand("diff", project, true);
+        // TODO command.addFiles(resources);
+        byte[] result = command.executeToBytes();
+        if (patchLocation != null)
+            saveFile(patchLocation, result);
+        return new String(result);
+    }
+
+    private static void saveFile(String patchLocation, byte[] result) throws HgException {
+        FileOutputStream stream = null;
+        try {
+            stream = new FileOutputStream(patchLocation);
+            stream.write(result);
+        } catch (IOException e) {
+            throw new HgException(e.getLocalizedMessage(), e);
+        } finally {
+            if (stream != null)
+                try {
+                    stream.close();
+                } catch (IOException e) {
+                }
+        }
+    }
 }
diff -r 3fcd0e896979 -r f36ea3ff247e src/com/vectrace/MercurialEclipse/team/ActionExport.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/com/vectrace/MercurialEclipse/team/ActionExport.java	Sun Oct 26 20:05:58 2008 +0800
@@ -0,0 +1,123 @@
+/*******************************************************************************
+ * Copyright (c) 2008 VecTrace (Zingo Andersen) and others.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     VecTrace (Zingo Andersen) - implementation
+ *******************************************************************************/
+package com.vectrace.MercurialEclipse.team;
+
+import org.eclipse.core.resources.IProject;
+import org.eclipse.jface.action.IAction;
+import org.eclipse.jface.viewers.ISelection;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.jface.wizard.WizardDialog;
+import org.eclipse.swt.widgets.Shell;
+import org.eclipse.ui.IWorkbench;
+import org.eclipse.ui.IWorkbenchWindow;
+import org.eclipse.ui.IWorkbenchWindowActionDelegate;
+import org.eclipse.ui.PlatformUI;
+
+import com.vectrace.MercurialEclipse.wizards.ExportWizard;
+
+
+public class ActionExport implements IWorkbenchWindowActionDelegate 
+{
+
+  private IWorkbenchWindow window;
+//    private IWorkbenchPart targetPart;
+  private IStructuredSelection selection;
+    
+  public ActionExport() 
+  {
+    super();
+  }
+
+  /**
+   * We can use this method to dispose of any system
+   * resources we previously allocated.
+   * @see IWorkbenchWindowActionDelegate#dispose
+   */
+  public void dispose() 
+  {
+
+  }
+
+
+  /**
+   * We will cache window object in order to
+   * be able to provide parent shell for the message dialog.
+   * @see IWorkbenchWindowActionDelegate#init
+   */
+  public void init(IWorkbenchWindow w) 
+  {
+//    System.out.println("ActionPull:init(window)");
+    this.window = w;
+  }
+
+  /**
+   * The action has been activated. The argument of the
+   * method represents the 'real' action sitting
+   * in the workbench UI.
+   * @see IWorkbenchWindowActionDelegate#run
+   */
+  
+
+  public void run(IAction action) 
+  {
+    IProject proj;
+    String Repository;
+    Shell shell;
+    IWorkbench workbench;
+   
+    proj=MercurialUtilities.getProject(selection);
+    Repository=MercurialUtilities.getRepositoryPath(proj);
+    if(Repository==null)
+    {
+      Repository="."; //never leave this empty add a . to point to current path
+    }
+
+    //Get shell & workbench
+    workbench = PlatformUI.getWorkbench();
+    if((window !=null) && (window.getShell() != null))
+    {
+      shell=window.getShell();
+    }
+    else
+    {
+      shell = workbench.getActiveWorkbenchWindow().getShell();
+    }
+
+
+    
+    //Setup and run command
+    ExportWizard importWizard = new ExportWizard();
+    importWizard.init(workbench, selection);
+    
+    WizardDialog pullWizardDialog = new WizardDialog(shell,importWizard);
+//    pullWizardDialog.setBlockOnOpen(true); 
+    pullWizardDialog.open();
+  }
+  
+  
+  /**
+   * Selection in the workbench has been changed. We 
+   * can change the state of the 'real' action here
+   * if we want, but this can only happen after 
+   * the delegate has been created.
+   * @see IWorkbenchWindowActionDelegate#selectionChanged
+   */
+  public void selectionChanged(IAction action, ISelection in_selection) 
+  {
+    if( in_selection != null && in_selection instanceof IStructuredSelection )
+    {
+      selection = ( IStructuredSelection )in_selection;
+    }
+  }
+
+
+  
+}
diff -r 3fcd0e896979 -r f36ea3ff247e src/com/vectrace/MercurialEclipse/wizards/ExportPage.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/com/vectrace/MercurialEclipse/wizards/ExportPage.java	Sun Oct 26 20:05:58 2008 +0800
@@ -0,0 +1,169 @@
+/*******************************************************************************
+ * Copyright (c) 2006-2008 VecTrace (Zingo Andersen) and others.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     steeven                    - implementation 
+ *******************************************************************************/
+package com.vectrace.MercurialEclipse.wizards;
+
+import org.eclipse.jface.resource.ImageDescriptor;
+import org.eclipse.swt.SWT;
+import org.eclipse.swt.events.SelectionAdapter;
+import org.eclipse.swt.events.SelectionEvent;
+import org.eclipse.swt.layout.GridData;
+import org.eclipse.swt.layout.GridLayout;
+import org.eclipse.swt.widgets.Button;
+import org.eclipse.swt.widgets.Combo;
+import org.eclipse.swt.widgets.Composite;
+import org.eclipse.swt.widgets.Event;
+import org.eclipse.swt.widgets.FileDialog;
+import org.eclipse.swt.widgets.Label;
+import org.eclipse.swt.widgets.Listener;
+import org.eclipse.swt.widgets.Text;
+
+/*
+ * A wizard page which will allow the user to choose location to export patch.
+ * 
+ */
+
+public class ExportPage extends SyncRepoPage {
+
+    private Label locationLabel;
+    private Combo locationCombo;
+    private GridData locationData;
+
+    private Label cloneParametersLabel;
+    private Label projectNameLabel;
+    private Combo projectNameCombo;
+    String repoName;
+    private Text projectNameText;
+
+    /**
+     * @param pageName
+     */
+    public ExportPage(String pageName, String title, String description,
+            String repoName, ImageDescriptor titleImage) {
+        super(pageName, title, titleImage);
+        this.repoName = repoName;
+        setDescription(description);
+    }
+
+    @Override
+    public boolean canFlipToNextPage() {
+        return isPageComplete() && (getWizard().getNextPage(this) != null);
+    }
+
+    @Override
+    public boolean isPageComplete() {
+        // This page has no smarts when it comes to parsing. As far as it is
+        // concerned
+        // / having any text is grounds for completion.
+        return (locationCombo.getText() != null);
+    }
+
+    @Override
+    protected boolean isPageComplete(String file) {
+        if (file != null) {
+            return true;
+        }
+        return false;
+    }
+
+    @Override
+    protected boolean validateAndSetComplete(String file) {
+        boolean validLocation = isPageComplete(file);
+
+        ((SyncRepoWizard) getWizard()).setLocationUrl(validLocation ? file
+                : null);
+
+        setPageComplete(validLocation);
+
+        return validLocation;
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see
+     * org.eclipse.jface.dialogs.IDialogPage#createControl(org.eclipse.swt.widgets
+     * .Composite)
+     */
+    @Override
+    public void createControl(Composite parent) {
+        Composite outerContainer = new Composite(parent, SWT.NONE);
+        GridLayout layout = new GridLayout();
+        layout.numColumns = 3;
+        outerContainer.setLayout(layout);
+        outerContainer.setLayoutData(new GridData(GridData.GRAB_HORIZONTAL
+                | GridData.HORIZONTAL_ALIGN_FILL));
+
+        projectNameLabel = new Label(outerContainer, SWT.NONE);
+        projectNameLabel.setText(Messages
+                .getString("ExportPage.projectNameLabel")); //$NON-NLS-1$
+
+        projectNameText = new Text(outerContainer, SWT.NONE);
+        projectNameText.setText(repoName);
+        projectNameText.setEnabled(false);
+        locationData = new GridData();
+        locationData.horizontalSpan= 2;
+        projectNameText.setLayoutData(locationData);
+
+        // Box to enter the repo location
+        locationLabel = new Label(outerContainer, SWT.NONE);
+        locationLabel.setText(Messages
+                .getString("ImportPage.locationLabel.text")); //$NON-NLS-1$
+        locationData = new GridData();
+        locationData.widthHint = 300;
+        locationCombo = new Combo(outerContainer, SWT.DROP_DOWN);
+        locationCombo.setLayoutData(locationData);
+        locationCombo.addListener(SWT.Selection, new Listener() {
+            public void handleEvent(Event event) {
+                validateAndSetComplete(locationCombo.getText());
+            }
+        });
+        locationCombo.addListener(SWT.Modify, new Listener() {
+            public void handleEvent(Event event) {
+                validateAndSetComplete(locationCombo.getText());
+            }
+        });
+        Button browseButton = new Button(outerContainer, SWT.PUSH);
+        browseButton
+                .setText(Messages.getString("ImportPage.browseButton.text")); //$NON-NLS-1$
+        browseButton.addSelectionListener(new SelectionAdapter() {
+            @Override
+            public void widgetSelected(SelectionEvent e) {
+                FileDialog dialog = new FileDialog(getShell(), SWT.SAVE);
+                dialog.setText(Messages.getString("ExportPage.dialog")); //$NON-NLS-1$
+                String file = dialog.open();
+                if (file != null) {
+                    locationCombo.setText(file);
+                }
+            }
+        });
+
+        setControl(outerContainer);
+        setPageComplete(false);
+    }
+
+    @Override
+    public void dispose() {
+        locationLabel.dispose();
+        locationCombo.dispose();
+        if (cloneParametersLabel != null) {
+            cloneParametersLabel.dispose();
+        }
+
+        if (projectNameLabel != null) {
+            projectNameLabel.dispose();
+        }
+        if (projectNameCombo != null) {
+            projectNameCombo.dispose();
+        }
+        if (projectNameText != null)
+            projectNameText.dispose();
+    }
+}
diff -r 3fcd0e896979 -r f36ea3ff247e src/com/vectrace/MercurialEclipse/wizards/ExportWizard.java
--- /dev/null	Thu Jan 01 00:00:00 1970 +0000
+++ b/src/com/vectrace/MercurialEclipse/wizards/ExportWizard.java	Sun Oct 26 20:05:58 2008 +0800
@@ -0,0 +1,88 @@
+/*******************************************************************************
+ * Copyright (c) 2008 VecTrace (Zingo Andersen) and others.
+ * All rights reserved. This program and the accompanying materials
+ * are made available under the terms of the Eclipse Public License v1.0
+ * which accompanies this distribution, and is available at
+ * http://www.eclipse.org/legal/epl-v10.html
+ *
+ * Contributors:
+ *     VecTrace (Zingo Andersen) - implementation
+ *     Stefan Groschupf          - logError
+ *     Stefan C                  - Code cleanup
+ *******************************************************************************/
+package com.vectrace.MercurialEclipse.wizards;
+
+import org.eclipse.core.resources.IProject;
+import org.eclipse.jface.viewers.IStructuredSelection;
+import org.eclipse.ui.IWorkbench;
+
+import com.vectrace.MercurialEclipse.MercurialEclipsePlugin;
+import com.vectrace.MercurialEclipse.commands.HgImportExportClient;
+import com.vectrace.MercurialEclipse.team.MercurialUtilities;
+
+public class ExportWizard extends SyncRepoWizard {
+
+    IProject project;
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see org.eclipse.ui.IWorkbenchWizard#init(org.eclipse.ui.IWorkbench,
+     * org.eclipse.jface.viewers.IStructuredSelection)
+     */
+    @Override
+    public void init(IWorkbench workbench, IStructuredSelection selection) {
+        project = MercurialUtilities.getProject(selection);
+        projectName = project.getName();
+        setWindowTitle(Messages.getString("ExportWizard.WindowTitle")); //$NON-NLS-1$
+        setNeedsProgressMonitor(true);
+        super.syncRepoLocationPage = new ExportPage(
+                Messages.getString("ExportWizard.pageName"), Messages.getString("ExportWizard.pageTitle"), Messages.getString("ExportWizard.pageDescription"), projectName, null); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
+    }
+
+    /*
+     * (non-Javadoc)
+     * 
+     * @see org.eclipse.jface.wizard.Wizard#performFinish()
+     */
+    @Override
+    public boolean performFinish() {
+        // final IWorkspace workspace = ResourcesPlugin.getWorkspace();
+        // final IProject project = workspace.getRoot().getProject(projectName);
+        final String exportFile = locationUrl;
+
+        // Check that this project exist.
+        if (project.getLocation() == null) {
+            // System.out.println( "Project " + projectName +
+            // " don't exists why pull?");
+            return false;
+        }
+
+        try {
+            HgImportExportClient.exportPatch(project, null,
+                    exportFile);
+            project.refreshLocal(1, null);
+/*
+            if (result.length() != 0) {
+                Shell shell;
+                IWorkbench workbench;
+
+                workbench = PlatformUI.getWorkbench();
+                shell = workbench.getActiveWorkbenchWindow().getShell();
+                
+                MessageDialog
+                        .openInformation(
+                                shell,
+                                Messages
+                                        .getString("ExportWizard.outputMessageDialog.title"), result); //$NON-NLS-1$
+            }
+*/
+        } catch (Exception e) {
+            MercurialEclipsePlugin.logError(Messages
+                    .getString("ExportWizard.exportOperationFailed"), e); //$NON-NLS-1$
+        }
+
+        return true;
+    }
+
+}
diff -r 3fcd0e896979 -r f36ea3ff247e src/com/vectrace/MercurialEclipse/wizards/messages.properties
--- a/src/com/vectrace/MercurialEclipse/wizards/messages.properties	Sat Oct 18 17:09:47 2008 +0200
+++ b/src/com/vectrace/MercurialEclipse/wizards/messages.properties	Sun Oct 26 20:05:58 2008 +0800
@@ -5,6 +5,11 @@
 ImportWizard.WizardPurpose=Clone Repository
 ImportWizard.pageDescription=Select a patch file to Import from
 ImportWizard.importOperationFailed=import operation failed
+ExportWizard.pageName=ExportPage
+ExportWizard.pageTitle=Export changes to patchfile
+ExportPage.dialog=Select a file to export to
+ExportWizard.pageDescription=Select a patch file to Export to
+ExportWizard.exportOperationFailed=export operation failed
 ImportPage.locationLabel.text=Patch file:
 ImportPage.browseButton.text=Browse...
 CompareAction.label=Compare
@@ -75,6 +80,8 @@
 ConfigurationWizardMainPage.passwordLabel.text=Password
 ImportPage.projectNameLabel.text=Name of project to Import to:
 ImportWizard.outputMessageDialog.title=Mercurial Eclipse Import output
+ExportPage.projectNameLabel=Project to export from:
+ExportWizard.outputMessageDialog.title=Mercurial Eclipse Export output
 IncomingPage.fileStatusTable.columnTitle.status=Status
 IncomingPage.fileStatusTable.columnTitle.path=Path
 IncomingPage.unknownElement=Unknown Element: 
@@ -235,3 +242,4 @@
 CreateProjectOperation.beginTask=Creating project...
 CreateProjectOperation.subTaskReadingProjectFile=Reading .project file...
 CreateProjectOperation.subTaskCreatingProjectFile=Creating .project file...
+ExportWizard.WindowTitle=Mercurial Export Wizard
