import java.io.BufferedInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

public class InputStreamConsumer extends Thread {
	private final InputStream stream;
	private final OutputStream output;

	public InputStreamConsumer(InputStream stream, OutputStream output) {
		this.output = output;
		this.stream = new BufferedInputStream(stream);
	}

	@Override
	public void run() {
		try {
			int length;
			byte[] buffer = new byte[8192];
			while ((length = stream.read(buffer)) != -1) {
				output.write(buffer, 0, length);
			}
		} catch (IOException e) {
			if (!interrupted()) {
				// HgClients.logError(e);
				e.printStackTrace();
			}
		} finally {
			try {
				this.stream.close();
			} catch (IOException e) {
				// HgClients.logError(e);
				e.printStackTrace();
			}
			try {
				output.close();
			} catch (IOException e) {
				// HgClients.logError(e);
				e.printStackTrace();
			}
		}
	}
}
